---
title: Cache.addAll()
slug: Web/API/Cache/addAll
tags:
  - API
  - Cache
  - Experimental
  - Method
  - NeedsExample
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
  - addAll
---
<p>{{APIRef("Service Workers API")}}</p>

<p><span class="seoSummary">The <strong><code>addAll()</code></strong> method of the {{domxref("Cache")}} interface takes an array of URLs, retrieves them, and adds the resulting response objects to the given cache. The request objects created during retrieval become keys to the stored response operations. </span></p>

<div class="note">
<p><strong>Note</strong>: <code>addAll()</code> will overwrite any key/value pairs previously stored in the cache that match the request, but will fail if a resulting <code>put()</code> operation would overwrite a previous cache entry stored by the same <code>addAll()</code> method.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>cache</em>.addAll(<em>requests</em>[]).then(function() {
  // requests have been added to the cache
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>requests</dt>
 <dd>An array of string URLs that you want to be fetched and added to the cache. You can specify the {{domxref("Request")}} object instead of the URL.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves with <code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col"><strong>Exception</strong></th>
   <th scope="col"><strong>Happens when</strong></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TypeError</code></td>
   <td>
    <p>The URL scheme is not <code>http</code> or <code>https</code>.</p>

    <p>The Response status is not in the 200 range (i.e., not a successful response.) This occurs if the request does not return successfully, but also if the request is a <em>cross-origin no-cors</em> request (in which case the reported status is always 0.)</p>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This code block waits for an {{domxref("InstallEvent")}} to fire, then runs {{domxref("ExtendableEvent.waitUntil","waitUntil()")}} to handle the install process for the app. This consists of calling {{domxref("CacheStorage.open")}} to create a new cache, then using <code>addAll()</code> to add a series of assets to it.</p>

<pre class="brush: js notranslate">this.addEventListener('install', function(event) {
  event.waitUntil(
    caches.open('v1').then(function(cache) {
      return cache.addAll([
        '/sw-test/',
        '/sw-test/index.html',
        '/sw-test/style.css',
        '/sw-test/app.js',
        '/sw-test/image-list.js',
        '/sw-test/star-wars-logo.jpg',
        '/sw-test/gallery/',
        '/sw-test/gallery/bountyHunters.jpg',
        '/sw-test/gallery/myLittleVader.jpg',
        '/sw-test/gallery/snowTroopers.jpg'
      ]);
    })
  );
});
</pre>

<h3 id="Specifications">Specifications</h3>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-addAll', 'Cache: addAll')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Cache.addAll")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WorkerGlobalScope.caches")}}</li>
</ul>
